<template>
  <div class="content">
    <div class="item" v-for="item in patentMark" :key="item.id" :style="{'background':item.color}">
      <el-popover
        placement="bottom"
        width="200"
        trigger="hover">
      <div>
        <p><span style="color: #409EFF;">栏位：</span><span>{{ item.scratchField }}</span></p>
        <!-- <p>栏位：{{ item.scratchField }}</p> -->
        <p><span style="color: #409EFF;">选中文本：</span>{{ item.text }}</p>
        <p v-if="item.remark"><span style="color: #409EFF;">标注：</span>{{ item.remark }}</p>
      </div>
      <div slot="reference" style="height:100%;width:100%" @click.prevent.stop="runTo(item)"></div>
      </el-popover>
    </div>
  </div>
</template>

<script>
export default {
  props:['patentNo'],
  data() {
    return {
      patentMark:[]
    }
  },
  computed: {
    piZhuContrastList() {
      return this.$store.state.report.piZhuContrastList
    },
  },
  watch: {
    'piZhuContrastList'(val) {
      this.getPatentMark()
    },
    patentNo(val) {
      this.getPatentMark()
    },
  },
  mounted() {
    this.getPatentMark()
  },
  methods: {
    getPatentMark() {
      this.$nextTick(() => {
        this.patentMark=[]
        var a = ['摘要', '权利要求', '说明书']
        var b = this.piZhuContrastList.filter(item => {
          return item.patentNo == this.patentNo
        })
        /**方案一 */
        // a.forEach(item => {
        //   b.forEach((item2, index) => {
        //     if (item2.scratchField.indexOf(item) != -1) {
        //       this.patentMark.push(item2)
        //       // 每次都需要重新遍历全部，优化
        //     }
        //   })
        // })
        /**方案二 */
        // var c = []
        // a.forEach((item,index) => {
        //   c[index] = []
        // })
        // b.forEach((item2) => {
        //   var index = a.findIndex(item => { return item2.scratchField.indexOf(item) != -1 })
        //   c[index].push(item2)
        // })
        // a.forEach((item,index) => {
        //   c[index].sort((a, b) => {
        //     return (a.position + a.text.length) - (b.position + b.text.length)
        //   })
        // })
        // this.patentMark = [].concat(...c)
        /**方案三 */
        // this.patentMark=b.sort((x,y)=>{
        //     return a.findIndex(item=>{return x.scratchField.indexOf(item)!=-1}) - a.findIndex(item=>{return y.scratchField.indexOf(item)!=-1})
        // })
        /**方案四 */
        var c = []
        a.forEach((item,index) => {
          c[index] = b.filter(item2 => {
            return item2.scratchField.indexOf(item) != -1  
          })
          c[index].sort((a, b) => {
            return a.position - b.position
          })
        })
        this.patentMark = [].concat(...c)
      })
    },
    runTo(val) {
      this.$emit('biaozhu',val)
    }
  },
}
</script>

<style lang="scss" scoped>
.item{
  width: 8px;
  height: 8px;
  border: 1px solid black;
  margin:2px 2px;
}
.content{
  max-width: 300px;
  max-height: 50px;
  overflow: auto;
  display: flex;
  flex-wrap: wrap;
}
</style>